{
module While_Parser (parser) where
import JavaLexer
}

%name statement
%name returnstatement
%name whilestatement
%name ifthenstatement
%name ifthenelsestatement
%tokentype { Token }
%error { parseError }
  
%token 
       ELSE { ELSE }
       RETURN { RETURN }
       WHILE { WHILE }
       IF { IF }
       INTLITERAL { INTLITERAL $$}
       BOOLLITERAL { BOOLLITERAL $$}
       LBRACE { LBRACE }
       RBRACE { RBRACE }
       LBRACKET { LBRACKET }
       RBRACKET { RBRACKET }
       SEMICOLON { SEMICOLON }
%%



statement        : ifthenstatement { $1 }
		 | ifthenelsestatement { $1 }
		 | whilestatement { $1 }
                 | block { $1 }
		 | emptystatement { $1 }
		 | returnstatement { $1 }

ifthenstatement  : IF LBRACE bexpression  RBRACE  statement { If($3, $5, Nothing) }

ifthenelsestatement : IF LBRACE bexpression  RBRACE statement ELSE statement  {If($3, $5, Just $7)  }

whilestatement   : WHILE LBRACE bexpression  RBRACE  statement { While($3, $5) }

block            : LBRACKET   RBRACKET { Block([Empty]) }
                 | LBRACKET  statements  RBRACKET { Block($2) }

statements  : statement { [$1] }
            | statements statement { $1 ++ [$2] }

emptystatement	 :  SEMICOLON  { Empty }

returnstatement  : RETURN  SEMICOLON  { Return Nothing }
                 | RETURN expression  SEMICOLON { Return (Just $2) }

bexpression : BOOLLITERAL { T -- eine wenig ungenau, nimmt alle boolliterals}  

expression :  INTLITERAL { One -- ein wenig ungenau, nimmt alle intliterals}

{

data Stmt = If(BExpr, Stmt , Maybe Stmt)
          | While( BExpr , Stmt )
          | Block([Stmt])
          | Empty
          | Return( Maybe Expr )
          deriving (Show)

data BExpr = T
     deriving (Show)

data Expr = One
     deriving (Show)

parseError :: [Token] -> a
parseError _ = error "Parse error"

--parser :: String -> MiniFunkExpr
parser = statement . alexScanTokens

main = do
  s <- readFile "/Users/pl/Lehre/Uni_Ausgewaehlte_Themen_PS_CB_INF3189/Loesungen/fst.stmt"
  --s <- getContents
  --print ((expr . alexScanTokens) s)
  print (parser s)
}

